Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Friends

# OGRCurvePolygon Class Reference

Concrete class representing curve polygons. More...

`#include <ogr_geometry.h>`

Inheritance diagram for OGRCurvePolygon:

List of all members.

## Public Member Functions
| OGRCurvePolygon ()
| Create an empty curve polygon.
virtual const char * | getGeometryName () const
| Fetch WKT name for geometry type.
virtual OGRwkbGeometryType | getGeometryType () const
| Fetch geometry type.
virtual OGRGeometry * | clone () const
| Make a copy of this object.
virtual void | empty ()
| Clear geometry information.
virtual OGRErr | transform (OGRCoordinateTransformation *poCT)
| Apply arbitrary coordinate transformation to geometry.
virtual void | flattenTo2D ()
| Convert geometry to strictly 2D.
virtual OGRBoolean | IsEmpty () const
| Returns TRUE (non-zero) if the object has no points.
virtual void | segmentize (double dfMaxLength)
| Add intermediate vertices to a geometry.
virtual OGRBoolean | hasCurveGeometry (int bLookForNonLinear=FALSE) const
virtual OGRGeometry * | getLinearGeometry (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=NULL) const
virtual double | get_Area () const
| Get the area of the surface object.
virtual int | PointOnSurface (OGRPoint *poPoint) const
| This method relates to the SFCOM ISurface::get_PointOnSurface() method.
virtual int | WkbSize () const
| Returns size of related binary representation.
virtual OGRErr | importFromWkb (unsigned char *, int=-1, OGRwkbVariant=wkbVariantOldOgc)
| Assign geometry from well known binary data.
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *, OGRwkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known binary format.
virtual OGRErr | importFromWkt (char **)
| Assign geometry from well known text data.
virtual OGRErr | exportToWkt (char **ppszDstText, OGRwkbVariant eWkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known text format.
virtual int | getDimension () const
| Get the dimension of this object.
virtual void | getEnvelope (OGREnvelope *psEnvelope) const
| Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.
virtual void | getEnvelope (OGREnvelope3D *psEnvelope) const
| Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.
virtual OGRPolygon * | CurvePolyToPoly (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=NULL) const
| Return a polygon from a curve polygon.
virtual OGRBoolean | Equals (OGRGeometry *) const
| Returns TRUE if two geometries are equivalent.
virtual OGRBoolean | Intersects (const OGRGeometry *) const
| Do these features intersect?
virtual OGRBoolean | Contains (const OGRGeometry *) const
| Test for containment.
virtual void | setCoordinateDimension (int nDimension)
| Set the coordinate dimension.
OGRErr | addRing (OGRCurve *)
| Add a ring to a polygon.
OGRErr | addRingDirectly (OGRCurve *)
| Add a ring to a polygon.
OGRCurve * | getExteriorRingCurve ()
| Fetch reference to external polygon ring.
const OGRCurve * | getExteriorRingCurve () const
int | getNumInteriorRings () const
| Fetch the number of internal rings.
OGRCurve * | getInteriorRingCurve (int)
| Fetch reference to indicated internal ring.
const OGRCurve * | getInteriorRingCurve (int) const
OGRCurve * | stealExteriorRingCurve ()
| "Steal" reference to external ring.
virtual void | swapXY ()
| Swap x and y coordinates.
## Protected Member Functions
virtual OGRSurfaceCasterToPolygon | GetCasterToPolygon () const
virtual OGRSurfaceCasterToCurvePolygon | GetCasterToCurvePolygon () const
## Static Protected Member Functions
static OGRPolygon * | CastToPolygon (OGRCurvePolygon *poCP)
| Convert to polygon.
## Protected Attributes
OGRCurveCollection | oCC
## Friends
class | OGRPolygon

## Detailed Description

Concrete class representing curve polygons.

Note that curve polygons consist of one outer (curve) ring, and zero or more inner rings. A curve polygon cannot represent disconnected regions (such as multiple islands in a political body). The OGRMultiSurface must be used for this.

Compatibility: ISO SQL/MM Part 3.

Since:
  GDAL 2.0

## Member Function Documentation

OGRErr OGRCurvePolygon::addRing | ( | OGRCurve * | poNewRing | ) |

Add a ring to a polygon.

If the polygon has no external ring (it is empty) this will be used as the external ring, otherwise it is used as an internal ring. The passed OGRCurve remains the responsibility of the caller (an internal copy is made).

This method has no SFCOM analog.

Parameters:

  | poNewRing | ring to be added to the polygon.

Returns:
  OGRERR_NONE in case of success

OGRErr OGRCurvePolygon::addRingDirectly | ( | OGRCurve * | poNewRing | ) |

Add a ring to a polygon.

If the polygon has no external ring (it is empty) this will be used as the external ring, otherwise it is used as an internal ring. Ownership of the passed ring is assumed by the OGRCurvePolygon, but otherwise this method operates the same as OGRCurvePolygon::AddRing().

This method has no SFCOM analog.

Parameters:

  | poNewRing | ring to be added to the polygon.

Returns:
  OGRERR_NONE in case of success

OGRPolygon * OGRCurvePolygon::CastToPolygon | ( | OGRCurvePolygon * | poCP | ) | `[static, protected]`

Convert to polygon.

This method should only be called if the curve polygon actually only contains instances of OGRLineString. This can be verified if hasCurveGeometry(TRUE) returns FALSE. It is not intended to approximate curve polygons. For that use getLinearGeometry().

The passed in geometry is consumed and a new one returned (or NULL in case of failure).

Parameters:

  | poMS | the input geometry - ownership is passed to the method.

Returns:
  new geometry.

OGRGeometry * OGRCurvePolygon::clone | ( |  | ) | const`[virtual]`

Make a copy of this object.

This method relates to the SFCOM IGeometry::clone() method.

This method is the same as the C function OGR_G_Clone().

Returns:
  a new object instance with the same geometry, and spatial reference system as the original.

Implements OGRGeometry.

OGRBoolean OGRCurvePolygon::Contains | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Test for containment.

Tests if actual geometry object contains the passed geometry.

This method is the same as the C function OGR_G_Contains().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters:

  | poOtherGeom | the geometry to compare to this geometry.

Returns:
  TRUE if poOtherGeom contains this geometry, otherwise FALSE.

Reimplemented from OGRGeometry.

OGRPolygon * OGRCurvePolygon::CurvePolyToPoly | ( | double | dfMaxAngleStepSizeDegrees = `0`,
|  | const char *const * | papszOptions = `NULL` |
| ) |  |  | const`[virtual]`

Return a polygon from a curve polygon.

This method is the same as C function OGR_G_CurvePolyToPoly().

The returned geometry is a new instance whose ownership belongs to the caller.

Parameters:

  | dfMaxAngleStepSizeDegrees | the largest step in degrees along the arc, zero to use the default setting.
  | papszOptions | options as a null-terminated list of strings. Unused for now. Must be set to NULL.

Returns:
  a linestring

Since:
  OGR 2.0

Reimplemented in OGRPolygon.

void OGRCurvePolygon::empty | ( |  | ) | `[virtual]`

Clear geometry information.

This restores the geometry to it's initial state after construction, and before assignment of actual geometry.

This method relates to the SFCOM IGeometry::Empty() method.

This method is the same as the C function OGR_G_Empty().

Implements OGRGeometry.

OGRBoolean OGRCurvePolygon::Equals | ( | OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Returns TRUE if two geometries are equivalent.

This method is the same as the C function OGR_G_Equals().

Returns:
  TRUE if equivalent or FALSE otherwise.

Implements OGRGeometry.

OGRErr OGRCurvePolygon::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc` |
| ) |  |  | const`[virtual]`

Convert a geometry into well known binary format.

This method relates to the SFCOM IWks::ExportToWKB() method.

This method is the same as the C function OGR_G_ExportToWkb() or OGR_G_ExportToIsoWkb(), depending on the value of eWkbVariant.

Parameters:

  | eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  | pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.
  | eWkbVariant | What standard to use when exporting geometries with three dimensions (or more). The default wkbVariantOldOgc is the historical OGR variant. wkbVariantIso is the variant defined in ISO SQL/MM and adopted by OGC for SFSQL 1.2.

Returns:
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

Reimplemented in OGRPolygon.

virtual OGRErr OGRCurvePolygon::exportToWkt | ( | char ** | ppszDstText,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc` |
| ) |  |  | const`[virtual]`

Convert a geometry into well known text format.

This method relates to the SFCOM IWks::ExportToWKT() method.

This method is the same as the C function OGR_G_ExportToWkt().

Parameters:

  | ppszDstText | a text buffer is allocated by the program, and assigned to the passed pointer. After use, *ppszDstText should be freed with OGRFree().
  | eWkbVariant | the specification that must be conformed too : wbkVariantOgc for old-style 99-402 extended dimension (Z) WKB types wbkVariantIso for SFSQL 1.2 and ISO SQL/MM Part 3

Returns:
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

Reimplemented in OGRPolygon.

void OGRCurvePolygon::flattenTo2D | ( |  | ) | `[virtual]`

Convert geometry to strictly 2D.

In a sense this converts all Z coordinates to 0.0.

This method is the same as the C function OGR_G_FlattenTo2D().

Implements OGRGeometry.

double OGRCurvePolygon::get_Area | ( |  | ) | const`[virtual]`

Get the area of the surface object.

For polygons the area is computed as the area of the outer ring less the area of all internal rings.

This method relates to the SFCOM ISurface::get_Area() method.

Returns:
  the area of the feature in square units of the spatial reference system in use.

Implements OGRSurface.

int OGRCurvePolygon::getDimension | ( |  | ) | const`[virtual]`

Get the dimension of this object.

This method corresponds to the SFCOM IGeometry::GetDimension() method. It indicates the dimension of the object, but does not indicate the dimension of the underlying space (as indicated by OGRGeometry::getCoordinateDimension()).

This method is the same as the C function OGR_G_GetDimension().

Returns:
  0 for points, 1 for lines and 2 for surfaces.

Implements OGRGeometry.

void OGRCurvePolygon::getEnvelope | ( | OGREnvelope * | psEnvelope | ) | const`[virtual]`

Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope().

Parameters:

  | psEnvelope | the structure in which to place the results.

Implements OGRGeometry.

void OGRCurvePolygon::getEnvelope | ( | OGREnvelope3D * | psEnvelope | ) | const`[virtual]`

Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope3D().

Parameters:

  | psEnvelope | the structure in which to place the results.

Since:
  OGR 1.9.0

Implements OGRGeometry.

OGRCurve * OGRCurvePolygon::getExteriorRingCurve | ( |  | ) |

Fetch reference to external polygon ring.

Note that the returned ring pointer is to an internal data object of the OGRCurvePolygon. It should not be modified or deleted by the application, and the pointer is only valid till the polygon is next modified. Use the OGRGeometry::clone() method to make a separate copy within the application.

Relates to the SFCOM IPolygon::get_ExteriorRing() method.

Returns:
  pointer to external ring. May be NULL if the OGRCurvePolygon is empty.

const char * OGRCurvePolygon::getGeometryName | ( |  | ) | const`[virtual]`

Fetch WKT name for geometry type.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_GetGeometryName().

Returns:
  name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed.

Implements OGRGeometry.

Reimplemented in OGRPolygon.

OGRwkbGeometryType OGRCurvePolygon::getGeometryType | ( |  | ) | const`[virtual]`

Fetch geometry type.

Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result.

This method is the same as the C function OGR_G_GetGeometryType().

Returns:
  the geometry type code.

Implements OGRGeometry.

Reimplemented in OGRPolygon.

OGRCurve * OGRCurvePolygon::getInteriorRingCurve | ( | int | iRing | ) |

Fetch reference to indicated internal ring.

Note that the returned ring pointer is to an internal data object of the OGRCurvePolygon. It should not be modified or deleted by the application, and the pointer is only valid till the polygon is next modified. Use the OGRGeometry::clone() method to make a separate copy within the application.

Relates to the SFCOM IPolygon::get_InternalRing() method.

Parameters:

  | iRing | internal ring index from 0 to getNumInternalRings() - 1.

Returns:
  pointer to interior ring. May be NULL.

int OGRCurvePolygon::getNumInteriorRings | ( |  | ) | const

Fetch the number of internal rings.

Relates to the SFCOM IPolygon::get_NumInteriorRings() method.

Returns:
  count of internal rings, zero or more.

OGRErr OGRCurvePolygon::importFromWkb | ( | unsigned char * | pabyData,
|  | int | nSize = `-1`,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc` |
| ) |  |  | `[virtual]`

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters:

  | pabyData | the binary input data.
  | nSize | the size of pabyData in bytes, or zero if not known.
  | eWkbVariant | if wkbVariantPostGIS1, special interpretation is done for curve geometries code

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

Reimplemented in OGRPolygon.

OGRErr OGRCurvePolygon::importFromWkt | ( | char ** | ppszInput | ) | `[virtual]`

Assign geometry from well known text data.

The object must have already been instantiated as the correct derived type of geometry object to match the text type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKT() method.

This method is the same as the C function OGR_G_ImportFromWkt().

Parameters:

  | ppszInput | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

Reimplemented in OGRPolygon.

OGRBoolean OGRCurvePolygon::Intersects | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Do these features intersect?

Determines whether two geometries intersect. If GEOS is enabled, then this is done in rigerous fashion otherwise TRUE is returned if the envelopes (bounding boxes) of the two features overlap.

The poOtherGeom argument may be safely NULL, but in this case the method will always return TRUE. That is, a NULL geometry is treated as being everywhere.

This method is the same as the C function OGR_G_Intersects().

Parameters:

  | poOtherGeom | the other geometry to test against.

Returns:
  TRUE if the geometries intersect, otherwise FALSE.

Reimplemented from OGRGeometry.

OGRBoolean OGRCurvePolygon::IsEmpty | ( |  | ) | const`[virtual]`

Returns TRUE (non-zero) if the object has no points.

Normally this returns FALSE except between when an object is instantiated and points have been assigned.

This method relates to the SFCOM IGeometry::IsEmpty() method.

Returns:
  TRUE if object is empty, otherwise FALSE.

Implements OGRGeometry.

int OGRCurvePolygon::PointOnSurface | ( | OGRPoint * | poPoint | ) | const`[virtual]`

This method relates to the SFCOM ISurface::get_PointOnSurface() method.

NOTE: Only implemented when GEOS included in build.

Parameters:

  | poPoint | point to be set with an internal point.

Returns:
  OGRERR_NONE if it succeeds or OGRERR_FAILURE otherwise.

Implements OGRSurface.

Reimplemented in OGRPolygon.

void OGRCurvePolygon::segmentize | ( | double | dfMaxLength | ) | `[virtual]`

Add intermediate vertices to a geometry.

This method modifies the geometry to add intermediate vertices if necessary so that the maximum length between 2 consecutives vertices is lower than dfMaxLength.

Parameters:

  | dfMaxLength | maximum length between 2 consecutives vertices.

Reimplemented from OGRGeometry.

void OGRCurvePolygon::setCoordinateDimension | ( | int | nNewDimension | ) | `[virtual]`

Set the coordinate dimension.

This method sets the explicit coordinate dimension. Setting the coordinate dimension of a geometry to 2 should zero out any existing Z values. Setting the dimension of a geometry collection will not necessarily affect the children geometries.

Parameters:

  | nNewDimension | New coordinate dimension value, either 2 or 3.

Reimplemented from OGRGeometry.

OGRCurve * OGRCurvePolygon::stealExteriorRingCurve | ( |  | ) |

"Steal" reference to external ring.

After the call to that function, only call to stealInteriorRing() or destruction of the OGRCurvePolygon is valid. Other operations may crash.

Returns:
  pointer to external ring. May be NULL if the OGRCurvePolygon is empty.

void OGRCurvePolygon::swapXY | ( |  | ) | `[virtual]`

Swap x and y coordinates.

Since:
  OGR 1.8.0

Reimplemented from OGRGeometry.

OGRErr OGRCurvePolygon::transform | ( | OGRCoordinateTransformation * | poCT | ) | `[virtual]`

Apply arbitrary coordinate transformation to geometry.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

Note that this method does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry.

This method is the same as the C function OGR_G_Transform().

Parameters:

  | poCT | the transformation to apply.

Returns:
  OGRERR_NONE on success or an error code.

Implements OGRGeometry.

int OGRCurvePolygon::WkbSize | ( |  | ) | const`[virtual]`

Returns size of related binary representation.

This method returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries.

This method relates to the SFCOM IWks::WkbSize() method.

This method is the same as the C function OGR_G_WkbSize().

Returns:
  size of binary representation in bytes.

Implements OGRGeometry.

Reimplemented in OGRPolygon.

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrcurvepolygon.cpp

Generated for GDAL by 1.7.1.